﻿var R = R || {};

R.dustAlive = 0;

//
R.Dust = function()
{
    Phaser.Sprite.call(this, game, 0, 0, 'play', 'dust1');
    this.anchor.set(0.5);    
    
    this.velX = 0;
    this.velY = 0;
    this.gravity = 0;

    this.exists = false;
};

R.Dust.prototype = Object.create(Phaser.Sprite.prototype);
R.Dust.prototype.constructor = R.Dust;

R.Dust.prototype.updateFall = function()
{
    this.x += this.velX;
    this.velY += this.gravity;
    this.y += this.velY;

    if(this.y > 580)
    {        
        this.kill();
        --R.dustAlive;
    }
};

R.Dust.prototype.setup = function()
{
    this.velX = game.rnd.realInRange(-0.5, 0.5);
    this.velY = 0;
    this.gravity = game.rnd.realInRange(0.2, 0.6);
    ++R.dustAlive;
};

//
R.DustyRain = function(n)
{
    Phaser.Group.call(this, game);
  
    for(var i = 0; i < n; i++)
    {
        var d = new R.Dust();
        this.add(d);
    }

    this.n = n;

    R.dustAlive = 0;
};

R.DustyRain.prototype = Object.create(Phaser.Group.prototype);
R.DustyRain.prototype.constructor = R.DustyRain;

R.DustyRain.prototype.fall = function()
{
    var n = this.n;
    var d = null;

    while(n--)
    {
        d = this.getFirstExists(false, false, game.rnd.between(0, game.width), game.rnd.between(0, 40), 'play', 'dust' + game.rnd.between(1, 4).toString());
        if(!d) break;
        d.setup();
    }
};

R.DustyRain.prototype.update = function()
{
    if(R.dustAlive === 0) return;

    var i = this.n;
    var d = null;
    while(i--)
    {
        d = this.children[i];
        if(d.exists) d.updateFall();
    }
};