﻿//
var HomeState = {

    bg: null, 
    labelScore: null,
    labelMaxLevel: null,
    logo: null,
    buttonPlay: null,   
    buttonMoreGames: null,
    eventShake: null,
    isw: 0,
    ish: 0,
    tws: [],
    crystals: [],

    //
    shutdown: function()
    {
        this.bg = null;        
        this.labelScore = null;
        this.labelMaxLevel = null;
        this.logo = null;
        this.buttonPlay = null;      
        this.buttonMoreGames = null;
        this.eventShake = null;
        this.tws.length = 0;
        this.crystals.length = 0;
    },

    create: function()
    {
        this.isw = 5;
        this.ish = 10;

        game.world.setBounds(-this.isw, 0, game.width + this.isw * 2, game.height + this.ish);

        this.bg = game.add.sprite(R.halfGameWidth, 0, 'bg_home');
        this.bg.anchor.x = 0.5;

        //
        var dx = (game.width - R.BASE_GAME_WIDTH) * 0.5;
        this.createCrystal(349 + dx, 430, 'crystall_blue', Math.PI * 0.04, 2000);
        this.createCrystal(732.5 + dx, 125, 'crystall_green', -Math.PI * 0.05, 1500);
        this.createCrystal(793 + dx, 82, 'crystall_violet', Math.PI * 0.03, 2500);

        //
        this.logo = game.add.sprite((game.width - R.BASE_GAME_WIDTH) * 0.5 + 238, -314, 'load', 'logo');
        
        //
        this.buttonPlay = R.createButton(R.halfGameWidth, -75, this.onPlayButton, this, 'mbtn_play', 'mbtn_play_pushed');
        this.buttonMoreGames = R.createButton(R.halfGameWidth - 12, -60, Publisher.moregamesRedirect, Publisher, 'mbtn_games', 'mbtn_games_pushed');
        this.buttonMoreGames.exists = Publisher.enableMoreGames;
        
        //
        this.labelScore = R.createText(R.halfGameWidth + 30, 35, 34, 'x ' + R.playerData.bestScore.toString(), '#eaa209');
        var chest = game.add.sprite(-this.labelScore.width * 0.5 - 38, -6, 'gui', 'chest_score');
        chest.anchor.set(0.5);
        this.labelScore.addChild(chest);

        this.labelMaxLevel = R.createText(R.halfGameWidth, 75, 34, R.strings.max_level + ': ' + R.playerData.maxLevel.toString(), '#eaa209');        

        //        
        this.tws.push(game.add.tween(this.buttonMoreGames).to({ y: 522 }, 400, Phaser.Easing.Linear.None, false, 0));
        this.tws.push(game.add.tween(this.buttonPlay).to({ y: 375 }, 300, Phaser.Easing.Linear.None, false, 400));
        this.tws.push(game.add.tween(this.logo).to({ y: 50 }, 300, Phaser.Easing.Linear.None, false, 700));
        
        if(R.sfx.stone_on_stone) for(var i in this.tws) this.tws[i].onComplete.add(function() { R.sfx.stone_on_stone.play(); }, this);

        this.tws[0].onComplete.add(function() { this.eventShake = game.time.events.loop(33, this.shakeUpdate, this) }, this);
        this.tws[this.tws.length - 1].onComplete.add(this.onCompleteSetup, this);        

        //
        this.enableButtons(false);
        Publisher.analyticsMenu();
        R.sceneTransition(200, null);

        if(R.sfx.music) R.sfx.music.resume();
    },

    resize: function(width, height)
    {
        if(this.tws.length > 0)
        {
            for(var i in this.twsi) this.tws[i].stop(false);
            this.tws.length = 0;
            this.onCompleteSetup();
        }

        this.bg.x = R.halfGameWidth;
        this.logo.position.set((width - R.BASE_GAME_WIDTH) * 0.5 + 238, 50);
        this.buttonPlay.position.set(R.halfGameWidth, 375);
        this.buttonMoreGames.position.set(R.halfGameWidth - 12, 522);

        this.tws.length = 0;
        this.tws.push(game.add.tween(this.buttonMoreGames).to({ x: this.buttonMoreGames.x + 6, y: this.buttonMoreGames.y + 10 }, 4000, Phaser.Easing.Quadratic.InOut, true, 0, -1, true));
        this.tws.push(game.add.tween(this.buttonPlay).to({ x: this.buttonPlay.x - 10, y: this.buttonPlay.y - 6 }, 5000, Phaser.Easing.Quadratic.InOut, true, 0, -1, true));
        this.tws.push(game.add.tween(this.logo).to({ x: this.logo.x + 6, y: this.logo.y - 10 }, 6000, Phaser.Easing.Quadratic.InOut, true, 0, -1, true));

        var dx = (width - R.BASE_GAME_WIDTH) * 0.5;
        this.crystals[0].x = 349 + dx;
        this.crystals[1].x = 732.5 + dx;
        this.crystals[2].x = 793 + dx;

        this.labelScore.x = R.halfGameWidth + 30;
        this.labelMaxLevel.x = R.halfGameWidth;
    },

    start: function()
    {
        for(var i in this.tws) this.tws[i].start();        
    },

    onCompleteSetup: function()
    {                
        this.resize(game.width, game.height);
        this.enableButtons(true);
        
        game.add.tween(this).to({ isw: 0, ish: 0 }, 1000, Phaser.Easing.Cubic.Out, true).onComplete.add(this.shakeEnd, this);

        this.tws.length = 0;
    },

    enableButtons: function(enable)
    {
        this.buttonPlay.inputEnabled = this.buttonMoreGames.inputEnabled = enable;
    },

    onPlayButton: function()
    {
        R.level = 1;
        R.score = 0;
        R.depth = 0;
        R.purposeDepth = 18;

        this.enableButtons(false);
        R.sceneTransition(200, 'play');
    },

    shakeUpdate: function()
    {
        game.camera.x = game.rnd.between(-this.isw, this.isw);
        game.camera.y = game.rnd.between(0, this.ish);
    },

    shakeEnd: function()
    {
        game.camera.position.set(0, 0);
        game.time.events.remove(this.eventShake);
        this.eventShake = null;
    },

    createCrystal: function(x, y, frame, r, duration)
    {
        var crystal = game.add.sprite(x, y, 'gui', frame);
        crystal.anchor.set(0.5, 0.0);
        crystal.rotation = r;
        game.add.tween(crystal).to({ rotation: -r }, duration, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
        this.crystals.push(crystal);
    }
};