﻿//
var LoadState = {
    
    logo: null,
    loading: null,   
    loadingBar: null,
    loadingTop: null,
    sfx_key: null,

    //
    init: function()
    {       
        game.load.onFileComplete.add(this.fileComplete, this);
        game.load.onLoadComplete.add(this.loadComplete, this);        
    },

    //
    create: function()
    {
        var userLanguage = window.navigator.language;
        userLanguage = userLanguage ? userLanguage : window.navigator.browserLanguage;
        userLanguage = userLanguage ? userLanguage.split("-")[0] : 'en';
        if(!R.existsInArray(Publisher.languagesSupported, userLanguage)) userLanguage = 'en';        
        
        //
        game.load.json('strings', 'assets/text/' + userLanguage + '.json');        
        game.load.atlas('gui', 'assets/atlas_gui.png', 'assets/atlas_gui.json');
        game.load.atlas('play', 'assets/atlas_play.png', 'assets/atlas_play.json');
        game.load.atlas('dwarf', 'assets/dwarf1.png', 'assets/dwarf1.json');
        game.load.image('bg_main', 'assets/bg_main.png');
        game.load.image('bg_home', 'assets/bg_home.png');

        if(game.device.webAudio)
        {
            var sfx_key = ['axe_hit', 'axe_stone_crushed', 'button', 'gameover', 'move_stone', 'new_game', 'score_add', 'score_got', 'stone_on_stone', 'throw', 'win', 'music'];
            for(var i in sfx_key) game.load.audio(sfx_key[i], ['assets/sfx/' + sfx_key[i] + '.ogg', 'assets/sfx/' + sfx_key[i] + '.mp3']);
            this.sfx_key = sfx_key;
        }

        this.createEnvironment();

        //
        game.load.start();
    },

    shutdown: function()
    {              
        this.loadingBar = null;
        this.sfx_key = null;
        this.logo = null;
        this.loading = null;
        this.loadingTop = null;
    },

    createEnvironment: function()
    {
        var tt = R.createText(0, 0, 40, '', '#1c9da0');

        game.stage.backgroundColor = '#230f19';
        game.canvas.parentElement.style.backgroundColor = '#071a33';

        this.logo = game.add.sprite(0, R.halfGameHeight - 100, 'load', 'logo');
        this.logo.anchor.set(0.5);

        this.loading = game.add.sprite(0, R.halfGameHeight + 200, 'load', 'loading');
        this.loading.anchor.set(0.5);

        this.loadingBar = game.add.sprite(0, this.loading.y - 21, 'load', 'loading_bar' + (game.rnd.between(1, 2).toString()));
        var cropRect = new Phaser.Rectangle(0, 0, 0, 44);
        this.loadingBar.crop(cropRect);             

        this.loadingTop = game.add.sprite(0, this.loading.y + 6, 'load', 'loading_top');
        this.loadingTop.anchor.x = 0.5;

        this.resize(game.width, game.height);
    },

    resize: function(width, height)
    {
        this.logo.x = R.halfGameWidth;
        this.loading.x = R.halfGameWidth;
        this.loadingBar.x = this.loading.x - this.loading.width * 0.5;
        this.loadingTop.x = this.loading.x;
    },

    //
    fileComplete: function(progress, cacheKey, success, totalLoaded, totalFiles)
    {
        this.loadingBar.cropRect.width = 176 * progress * 0.01;
        this.loadingBar.updateCrop();        
    },

    //
    loadComplete: function()
    {
        //sfx
        if(game.device.webAudio)
        {
            for(var i in this.sfx_key) R.sfx[this.sfx_key[i]] = game.add.audio(this.sfx_key[i]);
            R.sfx.music.onDecoded.add(function() { R.sfx.music.play("", 0, 1, true); }, this);
        }
               
        //         
        R.strings = game.cache.getJSON('strings');        
        R.loadGame();        
        R.sceneTransition(200, 'home');
    }
};