﻿var R = R || {};

//
R.BASE_GAME_WIDTH = 960;
R.BASE_GAME_HEIGHT = 640;

R.MAX_GAME_WIDTH = 1440;
R.MIN_GAME_WIDTH = 960;

R.gameWidth = R.BASE_GAME_WIDTH;
R.gameHeight = R.BASE_GAME_HEIGHT;
R.halfGameWidth = R.gameWidth * 0.5;
R.halfGameHeight = R.gameHeight * 0.5;

R.prevWindowWidth = 0;
R.prevWindowHeight = 0;

//
R.fontName = 'PassionOne';
R.strings = null;

R.level = 1;
R.score = 0;
R.depth = 0;
R.purposeDepth = 18;

R.sfx = {};

R.playerData = {
    bestScore: 0,
    maxLevel: 0,
    tutorial: true
};

R.saveGame = function()
{
    if(game.device.localStorage)
    {
        if(R.playerData.bestScore < R.score)
        {
            R.playerData.bestScore = R.score;
            Publisher.submitScore(R.score);
        }
        if(R.playerData.maxLevel < R.level) R.playerData.maxLevel = R.level;
        localStorage.setItem('Coolgames_GoldHunt_PlayerData', JSON.stringify(R.playerData));
    }
};

R.loadGame = function()
{
    if(game.device.localStorage)
    {
        var saveData = localStorage.getItem('Coolgames_GoldHunt_PlayerData');
        if(saveData) R.playerData = JSON.parse(saveData);
        if(!('tutorial' in R.playerData)) R.playerData.tutorial = true;
    }
};

//
R.existsInArray = function(arr, a)
{
    var i = arr.length;
    while(i--) if(arr[i] === a) return true;
    return false;
};

//
var game = null;

var startGame = function()
{
    var renderType = Phaser.AUTO;
    var ua = detect.parse(window.navigator.userAgent);
    if(ua.device.family == 'SM-T110' || ua.device.family == 'SM-T111') renderType = Phaser.CANVAS;

    game = new Phaser.Game(R.BASE_GAME_WIDTH, R.BASE_GAME_HEIGHT, renderType, 'gameContainer', BootState);
};