﻿var R = R || {};

//
R.Pike = function(x, y, a)
{
    Phaser.Sprite.call(this, game, x, y, 'play', 'pike');
    this.anchor.set(0.5);
    this.rotation = Phaser.Math.degToRad(a);
    
    this.startX = x;
    this.startY = y;
    this.startRot = this.rotation;

    this.throwing = false;

    this.box = null;
    this.visible = false;
    
    this.tween = null;
};

R.Pike.prototype = Object.create(Phaser.Sprite.prototype);
R.Pike.prototype.constructor = R.Pike;

R.Pike.prototype.updateSpin = function()
{
    this.rotation -= 0.3;
};

R.Pike.prototype.onTarget = function()
{
    this.position.set(this.startX, this.startY);
    this.rotation = this.startRot;
    this.throwing = false;    

    this.box.check();    
    this.box = null;
    this.visible = false;
    this.tween = null;

    if(R.sfx.axe_hit) R.sfx.axe_hit.play();
};

R.Pike.prototype.throw = function(box)
{    
    var distance = Phaser.Math.distance(this.x, this.y, box.x, box.y);
    var duration = distance / 2;    

    this.tween = game.add.tween(this).to({ x: box.x, y: box.y }, duration, Phaser.Easing.Linear.None, false);
    this.tween.onComplete.add(this.onTarget, this);
    this.tween.onUpdateCallback(this.updateSpin, this);

    this.box = box;
    this.throwing = true;    
};

R.Pike.prototype.go = function()
{
    this.tween.start();
    this.visible = true;
    if(R.sfx.throw) R.sfx.throw.play();
};

R.Pike.prototype.pause = function(p)
{
    if(this.tween) p ? this.tween.pause() : this.tween.resume();
};