﻿//
var PlayState = {    

    layerMain: null,   
    pauseScreen: null,
    endScreen: null,
    buttonHurry: null,
    buttonPause: null,  
    boxes: null,
    pike: null,
    mollyLeft: null,
    mollyRight: null,
    caveShadowRight: null,
    caveShadowLeft: null,
    tilesTop: null,
    tilesBottom: null,
    tilesBottomShadow: null,
    labelPlace: null,
    bgStuff: null,
    tweenKey: null,
    tweenMolly: null,
    dwarf: null,
    flame: null,
    prevDwarfFrame: 0,
    dustyRain: null,
    labelScore: null,
    labelDepth: null,
    flyScorePool: null,
    tutorial: null,

    //
    shutdown: function()
    {
        this.layerMain = null;
        this.buttonPause = null;
        this.buttonHurry = null;
        this.pauseScreen = null;
        this.boxes = null;
        this.pike = null;
        this.mollyLeft = null;
        this.mollyRight = null;
        this.caveShadowRight = null;
        this.caveShadowLeft = null;
        this.tilesTop = null;
        this.tilesBottom = null;
        this.tilesBottomShadow = null;
        this.labelPlace = null;
        this.bgStuff = null;
        this.tweenKey = null;
        this.tweenMolly = null;
        this.dwarf = null;
        this.flame = null;
        this.dustyRain = null;
        this.labelScore = null;
        this.labelDepth = null;
        this.flyScorePool = null;
        this.endScreen = null;
        this.tutorial = null;
    },

    create: function()
    {
        //
        game.world.setBounds(0, -R.intensityShake, game.width, game.height + R.intensityShake * 2);

        //
        this.tilesBottomShadow = new R.Background('play', 'tile_shadow_bottom');
        this.tilesBottomShadow.position.set(R.MIN_GAME_WIDTH, 453 - 37);

        this.tilesBottom = new R.Background('play', 'tile_bottom');
        this.tilesBottom.position.set(R.MIN_GAME_WIDTH - 14, 576);

        //
        this.layerMain = game.add.group();

        this.mollyLeft = this.layerMain.create(122, 358, 'play', 'crystal_molly_left');
        this.mollyLeft.anchor.set(0.5);       
        this.mollyRight = this.layerMain.create(331, 361, 'play', 'crystal_molly_right');
        this.mollyRight.anchor.set(0.5);            

        this.layerMain.create(0, 28, 'bg_main');        

        //
        this.caveShadowRight = this.layerMain.create(361, 347, 'play', 'cave_shadow_right');
        this.caveShadowRight.anchor.set(0.5);

        this.caveShadowLeft = this.layerMain.create(118.5, 329.5, 'play', 'cave_shadow_left');
        this.caveShadowLeft.anchor.set(0.5);               

        var key = this.layerMain.create(268, 389, 'play', 'key');
        key.anchor.set(0.5, 0.0);
        key.rotation = Math.PI * 0.05;
        
        //
        this.boxes = new R.BoxContainer(this.layerMain);
        this.layerMain.add(this.boxes);
        
        this.pike = new R.Pike(760, 460, -45);       
        this.layerMain.add(this.pike);            
        
        //
        this.tilesTop = new R.Background('play', 'tile_top');
        //
        this.bgStuff = new R.BackgroundStuff();
        //
        this.dustyRain = new R.DustyRain(80);        

        //dwarf
        this.dwarf = game.add.sprite(894, 546, 'dwarf', 'dwarf_idle1');
        this.dwarf.anchor.set(0.5, 1.0);        

        var frameNames = [];
        for(var i = 1; i < 5; i++) frameNames.push('dwarf_idle' + i.toString());
        for(var i = 3; i > 1; i--) frameNames.push('dwarf_idle' + i.toString());
        this.dwarf.animations.add('idle', frameNames, 13, true);

        var s = ['1', '2', '3', '4', '5', '3', '1', '6', '6', '6', '6', '6'];
        frameNames.length = 0;
        for(var i in s) frameNames.push('dwarf_throw' + s[i]);
        var anim = this.dwarf.animations.add('throw', frameNames, 25, false);
        anim.onStart.add(function() { this.position.x = 893; }, this.dwarf);
        anim.onComplete.add(function() { this.position.x = 894; this.animations.play('idle'); }, this.dwarf);
        anim.enableUpdate = true;
        anim.onUpdate.add(function(animation, frame) { if(frame.index === 14 && this.pike.tween) this.pike.go(); }, this);

        s = ['9', '8', '7', '6', '5', '4', '3', '2', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '1', '2', '3', '4', '5', '6', '7', '8'];
        frameNames.length = 0;
        for(var i in s) frameNames.push('dwarf_win' + s[i]);
        this.dwarf.animations.add('win', frameNames, 13, true);

        s = ['1', '2', '3', '4', '5', '5', '5', '5', '5', '5', '5', '5', '4', '3', '2'];
        frameNames.length = 0;
        for(var i in s) frameNames.push('dwarf_lose' + s[i]);
        this.dwarf.animations.add('lose', frameNames, 10, true);

        var flame = game.add.sprite(909, 0, 'dwarf', 'flame1');
        flame.anchor.set(0.5, 1.0);
        frameNames.length = 0;
        for(var i = 1; i < 7; i++) frameNames.push('flame' + i.toString());
        for(var i = 5; i > 1; i--) frameNames.push('flame' + i.toString());
        flame.animations.add('1', frameNames, 60, true).play();        
        this.flame = flame;
        this.prevDwarfFrame = 0;

        //gui        
        this.buttonHurry = R.createButton(100, 50, this.boxes.forcedNext, this.boxes, 'btn_arrow', 'btn_arrow_pushed');        
        this.buttonPause = R.createButton(0, 50, this.onPauseButton, this, 'btn_pause', 'btn_pause_pushed');
        this.labelPlace = game.add.sprite(0, 54, 'gui', 'labels');
        this.labelPlace.anchor.set(0.5);
        this.pauseScreen = new R.OptionsScreen();

        var labelLevel = R.createText(-120, -16, 28, R.strings.level + ': ' + R.level.toString(), '#1c9da0');        
        this.labelPlace.addChild(labelLevel);

        this.labelScore = R.createText(0, 5, 32, R.score.toString(), '#1c9da0');
        this.labelPlace.addChild(this.labelScore);

        this.labelDepth = R.createText(126, -16, 32, '1/' + R.purposeDepth.toString(), '#1c9da0');
        this.labelPlace.addChild(this.labelDepth);

        //FlyScore
        this.flyScorePool = game.add.group();
        for(var i = 0; i < 10; i++) this.flyScorePool.add(new R.FlyScore());

        //       
        this.tweenMolly = game.add.tween(this.mollyLeft).to({ alpha: 0 }, 2000, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
        this.tweenKey = game.add.tween(key).to({ rotation: -key.rotation }, 2000, Phaser.Easing.Quadratic.InOut, true, 0, -1, true);
        this.dwarf.animations.play('idle');

        //Tutorial
        if(R.playerData.tutorial) this.tutorial = new R.Tutorial(this.buttonHurry);        

        //
        this.buttonHurry.inputEnabled = this.buttonPause.inputEnabled = false;
        this.resize(game.width, game.height);
        R.sceneTransition(200, null);

        if(R.sfx.new_game) R.sfx.new_game.play();
        if(R.sfx.music) R.sfx.music.resume();
    },

    resize: function(width, height)
    {
        this.layerMain.x = 0;
        this.tilesTop.resize(width);
        this.buttonPause.x = width - 100;
        this.labelPlace.x = R.halfGameWidth;

        if(width > R.MIN_GAME_WIDTH)
        {
            this.tilesBottom.resize(width - this.tilesBottom.x);
            this.tilesBottomShadow.resize(width - this.tilesBottomShadow.x);
        }
        else
        {
            this.tilesBottom.removeAll(true, false);
            this.tilesBottomShadow.removeAll(true, false);
        }

        this.bgStuff.dotting(R.MIN_GAME_WIDTH);

        game.world.bringToTop(this.tilesTop);
        game.world.bringToTop(this.buttonHurry);
        game.world.bringToTop(this.labelPlace);
        game.world.bringToTop(this.buttonPause);
        game.world.bringToTop(this.flyScorePool);

        if(this.pauseScreen.exists)
        {
            this.pauseScreen.resize(width, height);
            game.world.bringToTop(this.pauseScreen);
        }
        else if(this.endScreen) this.endScreen.resize(width, height);
        else if(this.tutorial) this.tutorial.resize(width, height);
    },

    start: function()
    {        
        if(this.tutorial)
        {
            game.input.onDown.add(this.inputOnDownContinue, this);
            return;
        }

        game.input.onDown.add(this.inputOnDown, this);
        this.buttonHurry.inputEnabled = this.buttonPause.inputEnabled = true;
        this.boxes.next();
    },

    update: function()
    {
        this.mollyRight.alpha = 1 - this.mollyLeft.alpha;
        this.caveShadowLeft.alpha = this.mollyRight.alpha;
        this.caveShadowRight.alpha = this.mollyLeft.alpha;

        if(this.prevDwarfFrame !== this.dwarf.frame) this.correctFlamePos(this.dwarf.frame);        
    },

    correctFlamePos: function(frame)
    {
        var y = 0;
        switch(frame)
        {
            case 0: y = 400; break;
            case 1: y = 401; break;
            case 2: y = 402; break;
            case 3: y = 404; break;            

            case 9: y = 400; break;
            case 10: y = 401; break;
            case 11: y = 402; break;
            case 12: y = 403; break;
            case 13: y = 404; break;
            case 14: y = 405; break;

            case 15: case 16: case 17: case 18: case 19: case 20: case 21: case 22: case 23: y = 400; break;

            case 4: y = 400; break;
            case 5: y = 401; break;
            case 6: y = 402; break;
            case 7: y = 403; break;
            case 8: y = 404; break;
        }
        this.flame.y = y;
        this.prevDwarfFrame = frame;
    },

    inputOnDownContinue: function(pointer, event)
    {
        if(R.playerData.tutorial)
        {
            R.playerData.tutorial = false;
            R.saveGame();
        }

        this.tutorial.destroy();
        this.tutorial = null;

        if(R.sfx.new_game) R.sfx.new_game.play();

        game.input.onDown.remove(this.inputOnDownContinue, this);

        this.dwarf.animations.paused ? this.onClosePauseScreen() : this.start();

        if(R.sfx.music) R.sfx.music.resume();
    },

    inputOnDown: function(pointer, event)
    {        
        if(this.pike.throwing || this.buttonHurry.getBounds().contains(pointer.x, pointer.y) || this.buttonPause.getBounds().contains(pointer.x, pointer.y)) return;    

        var box = this.boxes.pick(pointer.x, pointer.y);
        if(box)
        {
            this.pike.throw(box);            
            this.dwarf.animations.stop(true, false);
            this.dwarf.animations.play('throw');
            if(R.score > 0) this.changeScore(-1);
        }
    },

    onPauseButton: function(button)
    {
        game.input.onDown.remove(this.inputOnDown, this);
        this.buttonHurry.inputEnabled = this.buttonPause.inputEnabled = false;

        this.tweenKey.pause();
        this.tweenMolly.pause();
        this.boxes.pause(true);
        this.pike.pause(true);
        this.dwarf.animations.paused = true;
        this.flame.animations.paused = true;

        this.pauseScreen.open();

        if(R.sfx.music) R.sfx.music.pause();
    },    

    onClosePauseScreen: function()
    {
        this.tweenKey.resume();
        this.tweenMolly.resume();
        this.boxes.pause(false);
        this.pike.pause(false);
        this.dwarf.animations.paused = false;
        this.flame.animations.paused = false;

        game.input.onDown.add(this.inputOnDown, this);        
        this.buttonHurry.inputEnabled = this.buttonPause.inputEnabled = true;

        if(R.sfx.music) R.sfx.music.resume();
    },

    showTutorial: function()
    {
        this.tutorial = new R.Tutorial(this.buttonHurry);
        this.tutorial.resize(game.width, game.height);

        game.input.onDown.add(this.inputOnDownContinue, this);        
    },

    increaseDepth: function()
    {
        ++R.depth;
        this.labelDepth.text = R.depth.toString() + '/' + R.purposeDepth.toString();

        if(this.boxes.pillarsExist === R.maxCountWidth) this.getLose();
        else if(R.depth === R.purposeDepth) this.getWin();
    },

    changeScore: function(v)
    {
        R.score += v;
        this.labelScore.text = R.score.toString();
        if(v > 0 && R.sfx.score_add) R.sfx.score_add.play();
    },

    scoreCollapse: function(x, y, n, delay)
    {        
        var fs = this.flyScorePool.getFirstExists(false, false);
        if(!fs)
        {
            fs = new R.FlyScore();
            fs.exists = true;            
            this.flyScorePool.add(fs);            
        }
        fs.setup(x, y, this.labelScore.x + this.labelPlace.x, this.labelPlace.y + this.labelScore.y, n, delay);
        if(R.sfx.score_got) R.sfx.score_got.play();
    },

    endFlyScore: function(fs)
    {
        this.changeScore(fs.score);        
        game.add.tween(this.labelScore.scale).to({ x: 1.2, y: 1.2 }, 200, Phaser.Easing.Linear.None, true, 0, 0, true);
        fs.kill();
    },

    watchWinPike: function()
    {
        if(this.pike.throwing) return;

        game.time.events.removeAll();

        var freePlaceX = [];
        this.boxes.getFreePlaces(freePlaceX);

        var score = 100 * R.level;      
        for(var i in freePlaceX) this.scoreCollapse(freePlaceX[i], this.boxes.firstY, score, 500 + 100 * i);        
        
        this.endScreen = new R.EndScreen(true, 500 + 100 * freePlaceX.length);
        if(R.sfx.win) R.sfx.win.play();
    },

    getWin: function()
    {
        this.boxes.stop();
        game.input.onDown.remove(this.inputOnDown, this);
        this.buttonHurry.inputEnabled = this.buttonPause.inputEnabled = false;
        
        if(this.dwarf.animations.currentAnim.name === 'throw') this.dwarf.animations.currentAnim.onComplete.add(function() { this.animations.play('win'); this.position.x = 904.5; }, this.dwarf);
        else
        {
            this.dwarf.animations.play('win');
            this.dwarf.position.x = 904.5;
        }               

        game.time.events.loop(500, this.watchWinPike, this);
    },

    getLose: function()
    {
        this.boxes.stop();
        game.input.onDown.remove(this.inputOnDown, this);
        this.buttonHurry.inputEnabled = this.buttonPause.inputEnabled = false;

        this.dwarf.animations.play('lose');
        this.dwarf.position.x = 910;
        this.flame.x = 925;
        let pathArray = window.location.pathname.split('/');
            let newpath = '';
            if (pathArray[1] && pathArray[1] != 'arcade' && pathArray[1] != 'games') {
				newpath = '/' + pathArray[1];
            }
            scorepost(window.location.protocol + '//' + window.location.hostname + newpath + '/index.php?act=Arcade&do=newscore', {
              gname : 'GoldHunt_Origon',
              gscore: R.score
            });
        this.endScreen = new R.EndScreen(false, 500);           

        Publisher.analyticsLevelFailed(R.level);

        if(R.sfx.gameover) R.sfx.gameover.play();
    }
};


