﻿var R = R || {};

//
R.Tutorial = function(leftButton)
{
    Phaser.Group.call(this, game);   

    //arrows
    this.arrow1 = this.createArrow(leftButton.x, leftButton.y + 27);
    this.arrow2 = this.createArrow(0, 0);
    this.arrow3 = this.createArrow(0, 0);
    this.arrow4 = this.createArrow(0, 0);
    this.arrow5 = this.createArrow(0, 0);

    //
    this.labelT1 = this.createLabel(200, R.strings.t1);
    this.setLabelPosition(this.labelT1, this.labelT1.width * 0.5 + 10, leftButton.y + 56);

    this.labelT2 = this.createLabel(200, R.strings.t2);
    this.labelT3 = this.createLabel(100, R.strings.t3);
    this.labelT4 = this.createLabel(250, R.strings.t4);
    this.labelT5 = this.createLabel(160, R.strings.t5);
    this.labelT6 = this.createLabel(800, R.strings.t6);
    this.labelT7 = this.createLabel(600, game.device.desktop ? R.strings.t7d : R.strings.t7m);
    this.labelT7.fontSize = 32;
};

R.Tutorial.prototype = Object.create(Phaser.Group.prototype);
R.Tutorial.prototype.constructor = R.Tutorial;

R.Tutorial.prototype.createArrow = function(x, y, angle)
{
    var arrow = this.create(x, y, 'gui', 't_arrow');
    arrow.anchor.set(1.0, 0.5);
    arrow.angle = -90;
    arrow.scale.set(0.8);
    return arrow;
};

R.Tutorial.prototype.createLabel = function(maxWidth, text)
{
    var label = R.createText(0, 0, 28, text, '#eaa209', false, 0, true);
    label.anchor.y = 0.0;
    label.wordWrapWidth = maxWidth;

    var box = game.add.sprite(0, 0, R.bitmapData);
    box.alpha = 0.5;    
    var w = label.width + 8;
    var h = label.height + 2;
    box.scale.set(w / R.bmdSize, h / R.bmdSize);

    this.add(box);
    this.add(label);
    label.box = box;

    return label;
};

R.Tutorial.prototype.setLabelPosition = function(label, x, y)
{
    label.position.set(x, y);
    label.box.position.set(x - label.width * 0.5 - 4, y - 1);
};

R.Tutorial.prototype.resize = function(width, height)
{
    this.arrow2.position.set(R.halfGameWidth - 140, 55);
    this.arrow3.position.set(R.halfGameWidth - 15, 90);
    this.arrow4.position.set(R.halfGameWidth + 140, 55);
    this.arrow5.position.set(width - 100, this.arrow1.y);

    this.setLabelPosition(this.labelT2, R.halfGameWidth - 150, 85);
    this.setLabelPosition(this.labelT3, R.halfGameWidth - 20, 120);
    this.setLabelPosition(this.labelT4, R.halfGameWidth + 190, this.labelT2.y);
    this.setLabelPosition(this.labelT5, width - this.labelT5.box.width * 0.5 - 10, this.labelT1.y);
    this.setLabelPosition(this.labelT6, R.halfGameWidth, 270);
    this.setLabelPosition(this.labelT7, R.halfGameWidth, height - this.labelT7.height - 50);

    game.world.bringToTop(this);
};